#include "Dungeon.h"
#include <time.h>
#include <fstream>
#include <vector>
#define Room_Buffer 3

using namespace std;

Dungeon::Dungeon(int sz_x, int sz_y)
{
    log.open("log.txt");
    movecosts[0] = 4;
    movecosts[1] = 100;     //doesn't matter we never go through any rooms
    movecosts[2] = 1;
    movecosts[3] = 50;
    sz_X = sz_x;
    sz_Y = sz_y;
    num_rm = floor((sz_X*sz_Y)/((sz_X+sz_Y)));
    Rooms = new Room[num_rm];
    grid = new int*[sz_X];
    for(int i=0;i<sz_X;i++)
    {
        grid[i] = new int[sz_Y];
    }

    for(int x=0;x<sz_x;x++)
    {
        for(int y=0;y<sz_y;y++)
        {
            grid[x][y] = 0; //clear it
        }
    }
}
Dungeon::Dungeon(int sz_x, int sz_y,int Num_Room)
{
    log.open("log.txt");
    movecosts[0] = 10;
    movecosts[1] = 100;     //doesn't matter we never go through any rooms
    movecosts[2] = 1;
    movecosts[3] = 50;
    sz_X = sz_x;
    sz_Y = sz_y;

    num_rm = Num_Room;
    Rooms = new Room[Num_Room];

    grid = new int*[sz_X];
    for(int i=0;i<sz_X;i++)
    {
        grid[i] = new int[sz_Y];
    }

    for(int x=0;x<sz_x;x++)
    {
        for(int y=0;y<sz_y;y++)
        {
            grid[x][y] = 0; //clear it
        }
    }
}
void Dungeon::Gen_Rooms()
{
    for(int r = 0;r < num_rm; r++)
    {
        cout<<"r = "<<r<<endl;
        bool inuse = false;
        int x = 1+rand()%(sz_X-9);      //room x,y location
        int y = 1+rand()%(sz_Y-9);
        int x_off = 3+rand()%4;     //room size 3-7 wide and long
        int y_off = 3+rand()%4;

        cout<<"Attemping to place a room at ["<<x<<"]["<<y<<"]"<<endl
            <<"With size of ["<<x_off<<"]["<<y_off<<"]"<<endl;

        for(int q = -Room_Buffer;q < x_off + Room_Buffer && !inuse;q++)
        {
            for(int w = -Room_Buffer;w < y_off + Room_Buffer && !inuse;w++)
            {
                if((x+q >= 0 && y+w >= 0) && grid[x+q][y+w] == 1)
                {
                   inuse = true;   //it is in use!  Can't Make a room here
                   r--;            //Can't place room so we must try again
                }
            }
        }
        if(!inuse)                 //if ok to place a room here then place it!
        {
            Rooms[r].x = x;
            Rooms[r].y = y;
            Rooms[r].sz_x = x_off;
            Rooms[r].sz_y = y_off;
            for(int q = 0;q < x_off;q++)
            {
                for(int w = 0;w < y_off;w++)
                {
                    grid[x+q][y+w] = 1;
                }
            }
        }
    }
}
void Dungeon::Gen_Hallways()
{
    for(int r = 0;r < num_rm;r++)
    {
        int E = 1+rand()%2;
        for(int e = 0;e < E;e++)
        {
            Entrance new_entrance;
            int Wall = rand()%4;  //0 - 3
            switch(Wall)
            {
            case 0:
                if(Rooms[r].y != 0)
                {
                    new_entrance.x = Rooms[r].x+1+rand()%(Rooms[r].sz_x-2);
                    new_entrance.y = Rooms[r].y;
                    new_entrance.side = Wall;
                    grid[new_entrance.x][new_entrance.y] = 3;
                }
                else
                r--;
                break;

            case 1:
                if(Rooms[r].x+Rooms[r].sz_x != sz_X)
                {
                    new_entrance.x = Rooms[r].x+Rooms[r].sz_x-1;
                    new_entrance.y = Rooms[r].y+1+rand()%(Rooms[r].sz_y-2);
                    new_entrance.side = Wall;
                    grid[new_entrance.x][new_entrance.y] = 3;
                }
                else
                r--;
                break;

            case 2:
                if(Rooms[r].y+Rooms[r].sz_y != sz_Y)
                {
                    new_entrance.x = Rooms[r].x+1+rand()%(Rooms[r].sz_x-2);
                    new_entrance.y = Rooms[r].y+Rooms[r].sz_y-1;
                    new_entrance.side = Wall;
                    grid[new_entrance.x][new_entrance.y] = 3;
                }
                else
                r--;
                break;

            case 3:
                if(Rooms[r].x != 0)
                {
                    new_entrance.x = Rooms[r].x;
                    new_entrance.y = Rooms[r].y+1+rand()%(Rooms[r].sz_y-2);
                    new_entrance.side = Wall;
                    grid[new_entrance.x][new_entrance.y] = 3;
                }
                else
                r--;
                break;
            }
            Entrances.push_back(new_entrance);
        }
    }
    cout<<"Created "<<Entrances.size()<<" entrances to rooms."<<endl;
    for(unsigned int m = 0;m < Entrances.size();m++)
    {
        cout<<m<<") Entrance at "<<Entrances[m].x<<","<<Entrances[m].y<<endl;
    }
    for(unsigned int i = 0;i < Entrances.size()/2;i++)
    {
        AStar(i,Entrances.size()-(i+1));
    }
    for(unsigned int i = 1;i < Entrances.size()-1;i++)
    {
        AStar(0,i);
    }
}
void Dungeon::AStar(int e1,int e2)
{
    int time = clock();
    vector <Node> OpenList;
    vector <Node> ClosedList;
    int start = Entrances[e1].x+Entrances[e1].y*sz_X;
    int goal_id = Entrances[e2].x+Entrances[e2].y*sz_X;
    H_Values.clear();               //empty vector
    for(int i=0;i<sz_Y*sz_X;i++)    //populates H values vector
    {
        int x = i % sz_X;
        int y = i / sz_X;
        H_Values.push_back(abs(Entrances[e2].x-x) + abs(Entrances[e2].y-y));
    }

    Node Current;
    Node Test;

    Current.id = start;
    Current.Parent_Node = -1;
    Current.Cost = 0;
    cout<<"Looking for path to id: "<<goal_id<<endl;

    while(1)
    {
        ClosedList.push_back(Current);


        if(Current.id - sz_X >= 0)         // up
        {
            Test.id = Current.id - sz_X;   //set id one unit up
            if(Calculate_Costs(OpenList,ClosedList,Test,Current,goal_id))break;   //check to see if this is the goal
        }
        if(Current.id % sz_X != sz_X-1 )  // right
        {
            Test.id = Current.id + 1;     //set id one unit right
            if(Calculate_Costs(OpenList,ClosedList,Test,Current,goal_id))break;   //check to see if this is the goal
        }
        if(Current.id + sz_X < sz_X*sz_Y - 1)  // down
        {
            Test.id = Current.id + sz_X;   //set id one unit down
            if(Calculate_Costs(OpenList,ClosedList,Test,Current,goal_id))break;   //check to see if this is the goal
        }
        if(Current.id % sz_X != 0 )        // left
        {
            Test.id = Current.id - 1;      //set id one unit left
            if(Calculate_Costs(OpenList,ClosedList,Test,Current,goal_id))break;   //check to see if this is the goal
        }
        int q = Find_Lowest_Cost(OpenList);
        Current = OpenList[q];
        OpenList.erase(OpenList.begin()+q);
    }
    //make that hallway
    Node next = GetFromList(Test.Parent_Node, ClosedList);
    while(1)
    {
        grid[next.id%sz_X][next.id/sz_X] = 2;
        next = GetFromList(next.Parent_Node,ClosedList);
        if(next.id == start)break;
    }
    cout<<"Time to compute: "<<clock()-time<<" milliseconds"<<endl;
}
bool Dungeon::Calculate_Costs(vector <Node> &OpenList, vector <Node> &ClosedList, Node &toCalculate, Node &Parent, int goal)
{
    if(grid[toCalculate.id%sz_X][(int)floor(toCalculate.id/sz_X)] != 1)                                   //if this is a passable tile
    {
        if(!InList(toCalculate.id,ClosedList))                                                     //see if we are allowed to test closed list Nodes are untestable(fully resolved)
        {
            if(!InList(toCalculate.id,OpenList))                                                   //see if we have been here before(but not finalized)
            {                                                                               //we haven't been here so
                toCalculate.Parent_Node = Parent.id;                                               //set the parent id
                toCalculate.Cost = Parent.Cost + movecosts[grid[toCalculate.id%sz_X][toCalculate.id/sz_X]];      //find the cost to get here via the tile type lookup for costs
                OpenList.push_back(toCalculate);                                                   //add to open list
                if(toCalculate.id == goal)return true;                                             //If this is our goal tell the main function to stop calculating we have the solution
            }else
            {                                                                               //we have been here before
                toCalculate = GetFromList(toCalculate.id,OpenList);
                if(Parent.Cost + movecosts[grid[toCalculate.id%sz_X][toCalculate.id/sz_X]] < toCalculate.Cost)  //better route to spot?(less cost?)
                {
                    //OpenList[Find_ID(toCalculate.id,OpenList)].Parent_Node = Parent.id;
                    toCalculate.Parent_Node = Parent.id;                                           //reset parent id to reflect better route
                    toCalculate.Cost = Parent.Cost + movecosts[grid[toCalculate.id%sz_X][toCalculate.id/sz_X]]; //give it the new optimized movement cost.
                }
            }
        }
    }
    return false;
}

int  Dungeon::Find_ID(int id, vector <Node> n)
{
    for(unsigned int i = 0; i < n.size();i++)
        if(n[i].id == id)return i;
    return -1;
}
int  Dungeon::Find_Lowest_Cost(vector <Node> n)
{
    int lowest = n[0].Cost + H_Values[n[0].id];
    int lowestid = 0;
    for(unsigned int i=1;i<n.size();i++)
    {
        if(n[i].Cost + H_Values[n[i].id] < lowest)
        {
            lowest = n[i].Cost + H_Values[n[i].id];
            lowestid = i;
        }
    }
    return lowestid;
}

bool Dungeon::InList(int id, vector <Node> n)
{
    for(unsigned int i=0;i < n.size(); i++)
    {
        if(n[i].id == id)return true;
    }
    return false;
}

Node Dungeon::GetFromList(int id, vector <Node> n)
{
    for(unsigned int i = 0;i < n.size();i++)
    {
        if(n[i].id == id)return n[i];
    }
}

void Dungeon::Generate()
{
    Gen_Rooms();
    Gen_Hallways();
}
void Dungeon::Display()
{
    cout<<"Number of rooms = "<<num_rm<<endl;
    for(int y=0;y<sz_Y;y++)
    {
        for(int x=0;x<sz_X;x++)
        {
           switch(grid[x][y])
           {
           case 0:
              cout<<"#";
              break;
           case 1:
              cout<<".";
              break;
           case 2:
              cout<<" ";
              break;
           case 3:
              cout<<"@";
              break;
           default:
              cout<<"!";
              break;
           }
        }
        cout<<endl;
    }
}

Dungeon::~Dungeon()
{
    for(int i=0;i < sz_Y;i++)
    {
        delete [] grid[i];
    }
    delete [] grid;
}


