#ifndef DUNGEON_H
#define DUNGEON_H

#include <Math.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <vector>


using namespace std;

struct Room{int x;int y;int sz_x;int sz_y;};
struct Entrance{int x;int y;int side;};
struct Node{int id;int Parent_Node;int Cost;};

class Dungeon
{
    public:
        Dungeon(int sz_x, int sz_y);
        Dungeon(int sz_x, int sz_y,int Num_Room);
        void Gen_Rooms();
        void Gen_Hallways();
        void Generate();
        void Display();
        void Connect_Entrances(int e1,int e2);
        void AStar(int e1,int e2);
        bool Calculate_Costs(vector <Node> &OpenList, vector <Node> &ClosedList, Node &toCalculate, Node &Parent, int goal);
        int  Find_ID(int id, vector <Node> n);
        int  Find_Lowest_Cost(vector <Node> n);
        Node GetFromList(int id, vector <Node> n);
        bool InList(int id, vector <Node> n);
        ~Dungeon();

    private:
        ofstream log;
        int movecosts[4];
        vector <Entrance> Entrances;
        vector <int> H_Values;
        int sz_X, sz_Y;
        int num_rm;
        int **grid;
        Room *Rooms;

};

#endif // DUNGEON_H
